package Sort;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import support.ConnectionSql;
import support.DateHandle;
import update.UpdateRank;

public class SortWithTimeModel {
	String column = "newPostsCount";
	String tablename = "simple_test_newPostsCount";
	Connection conn = new ConnectionSql("ossean_db").connection();
	String date;
	int n;
	DateHandle dateHandle;

	public SortWithTimeModel(String date, int n) {
		// TODO Auto-generated constructor stub
		this.date = date;
		this.n = n;
		dateHandle = new DateHandle(date, n);
	}

	public static void main(String[] args) {
		SortWithTimeModel sort = new SortWithTimeModel("2014-09-31 00:00:00",
				12);
		sort.start();
	}

	/**
	 * 򣬸newPostCountֶκRank_newPostsCountֶ
	 */
	public void start() {
		Map<String, Double> count = getnewPostsCountTime();
		updateTable(conn, tablename, "postsCountTime", "DBMS", count);
		UpdateRank updateRank = new UpdateRank(tablename, "postsCountTime",
				"rank_PostsCountTime");
		updateRank.run();
	}

	/**
	 * Map±
	 * 
	 * @param conn
	 * @param tablename
	 * @param updatecolumn
	 * @param conditionColumn
	 * @param count
	 */
	public void updateTable(Connection conn, String tablename,
			String updatecolumn, String conditionColumn,
			Map<String, Double> count) {
		String sql = "update " + tablename + " set " + updatecolumn + "="
				+ "? where " + conditionColumn + " = ?";
		try {
			conn.setAutoCommit(false);
			PreparedStatement ps = conn.prepareStatement(sql);
			int flag = 1;
			Iterator<Map.Entry<String, Double>> iterator = count.entrySet()
					.iterator();
			System.out.println("start!");
			while (iterator.hasNext()) {
				Map.Entry<String, Double> entry = iterator.next();
				String key = entry.getKey();
				double value = (Double) entry.getValue();
				ps.setDouble(1, value);
				ps.setString(2, key);

				ps.addBatch();
				if (flag++ % 1000 == 0) {
					ps.executeBatch();
					ps.clearBatch();
					System.out.println("update: " + flag);
				}
			}
			ps.executeBatch();
			ps.clearBatch();
			ps.close();
			conn.commit();
			conn.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * ݲʱμ𣬷Ӱgenֵ
	 * 
	 * @param lev
	 * @return
	 */
	public double getGen(int lev) {
		return (double) lev / (lev + 1);
	}

	/**
	 * õtablenameĿƶӦһʱͨʱģͶĿӰֵ
	 * 
	 * @return
	 */
	public Map<String, Double> getnewPostsCountTime() {
		Map<String, Double> count = new HashMap<String, Double>();
		try {
			conn.setAutoCommit(false);
			ResultSet rs1;	
			Statement st1;	
			String projName;
			String sql;
			DateHandle dateHandle = new DateHandle();

			/**
			 * ʼMap countÿĿ
			 */
			sql = "select DBMS from simple_test_newpostscount";
			st1 = conn.createStatement();
			rs1 = st1.executeQuery(sql);
			while (rs1.next()) {
				count.put(rs1.getString(1), 0d);
			}
			rs1.close();
			st1.close();
			
			/**
			 * JDBCһѯдʱԸĽ
			 */
			
			sql = "create table temp "
					+ "SELECT p.id as id,s.DBMS as DBMS,s.tag_id as tag_id,p.lastActivityDate "
					+ "from simple_test_newpostscount_match as s "
					+ "INNER JOIN posts_split_tags as p ON s.tag_id=p.tag_id";
			st1 = conn.createStatement();
			st1.execute(sql);
			sql = "alter table temp add index index_id (id)";
			st1.execute(sql);
			conn.commit();
			st1.close();

			System.out.println("temp table create completement!");
			
			int page_count;
			int page_size;
			String lastActivityDate;
			int lev = 0;
			double gen = 0.0;
			boolean isEmpty;

			/**
			 * ÷ҳѯֹڴ
			 */

			page_count = 0; // ҳСҳ
			page_size = 1000;
			sql = "select DBMS,lastActivityDate from temp where id>(select id from temp order by id limit ?,1) limit ?";
			PreparedStatement ps = conn.prepareStatement(sql);
			do {
				ps.setInt(1, page_count * page_size);
				ps.setInt(2, page_size);
				rs1 = ps.executeQuery();
				isEmpty = true;
				while (rs1.next()) {
					isEmpty = false;
					projName = rs1.getString(1);
					lastActivityDate = rs1.getString(2);
					lev = dateHandle.levDate(lastActivityDate);
					gen = getGen(lev);
					count.put(projName, count.get(projName) + gen);
				}

				if (isEmpty) {
					break;
				}
				++page_count ;
				System.out.print(new Date());
				System.out.println("\t\t" + page_count);
				
			} while (true);
			rs1.close();
			ps.close();
			sql="drop table temp";
			st1=conn.createStatement();
			st1.execute(sql);
			st1.close();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		return count;
	}

	/**
	 * ݱûѡȫѡӦзؽResultSet
	 * 
	 * @param conn
	 * @param tablename
	 * @param column
	 * @param conditionColumn
	 * @param condition
	 * @return
	 * @throws SQLException
	 */
	public ResultSet getData(Connection conn, String tablename, String column,
			String conditionColumn, String condition) {
		String sql;
		ResultSet rs = null;
		if (!conditionColumn.isEmpty()) {
			sql = "select " + column + " from " + tablename + " where "
					+ conditionColumn + "=" + "'" + condition + "'";
		} else {
			sql = "select " + column + " from " + tablename;
		}
		try {
			Statement st = conn.createStatement();
			rs = st.executeQuery(sql);
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}

		// st.close();
		return rs;
	}

	/**
	 * ݱûѡȫѡӦзؽResultSet
	 * 
	 * @param conn
	 * @param tablename
	 * @param column
	 * @param conditionColumn
	 * @param condition
	 * @return
	 * @throws SQLException
	 */
	public ResultSet getData(Connection conn, String tablename, String column,
			String conditionColumn, int condition) {
		String sql;
		ResultSet rs = null;
		if (!conditionColumn.isEmpty()) {
			sql = "select " + column + " from " + tablename + " where "
					+ conditionColumn + "=" + condition;
		} else {
			sql = "select " + column + " from " + tablename;
		}
		try {
			Statement st = conn.createStatement();
			rs = st.executeQuery(sql);
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		return rs;
	}

}
